<template>
  <div>
    <client-only placeholder="Loading...">
      <vue-upload-multiple-image
        ref="uploader"
        @upload-success="uploadImageSuccess"
        @before-remove="beforeRemove"
        @edit-image="editImage"
        :data-images="images"
        idUpload="myIdUpload"
        editUpload="myIdEdit"
        dragText="Upuść tutaj plik"
        dropText="Upuść tutaj plik"
        browseText="(lub) wybierz go z dysku"
        primaryText=""
        :maxImage="number"
      ></vue-upload-multiple-image>
    </client-only>
    <template>
      <v-row justify="center">
        <v-dialog
          v-model="dialog"
          fullscreen
          hide-overlay
          transition="dialog-bottom-transition"
        >
          <template v-slot:activator="{ on, attrs }">
            <v-btn @click="getImages" style="margin-top: 20px;" text v-bind="attrs" v-on="on">
              Edytuj
            </v-btn>
          </template>
          <v-card>
            <v-toolbar dark>
              <v-btn text @click="dialog = false">
                <v-icon>mdi-close</v-icon>
              </v-btn>
              <v-toolbar-title>Kadrowanie</v-toolbar-title>
              <v-spacer></v-spacer>
            </v-toolbar>
            <v-subheader>Edytor</v-subheader>
            Kliknij na zdjęcie by je edytować
            <ImageManipulation
              @cropped="
                (data) => {
                  cropped(data);
                }
              "
              :images="images"
              @changed="
                (data) => {
                  changed(data.index, data.file);
                }
              "
            />
            <v-divider></v-divider>
          </v-card>
        </v-dialog>
      </v-row>
    </template>
  </div>
</template>
<script>
export default {
  name: "UploadImage",

  props: {
    number: {
      type: Number,
      default: 2,
    },

    change: {
      type: Object,
      required: false,
    },
  },

  data() {
    return {
      dialog: false,
      notifications: false,
      sound: true,
      widgets: false,
      editedFiles: [],
      images: [],
    };
  },

  methods: {
    uploadImageSuccess(formData, index, fileList) {
      console.log("data", formData, index, fileList);
      this.$emit("formData", formData);
    },

    beforeRemove(index, done, fileList) {
      console.log("index", index, fileList);
      var r = confirm("remove image");
      if (r == true) {
        done();
      } else {
      }
    },

    getImages() {
      this.images = this.$refs["uploader"].images;
    },

    editImage(formData, index, fileList) {
      console.log("edit data", formData, index, fileList);
    },

    cropped({ index, path }) {
      this.$refs.uploader.images[index].path = path;
    },
  },

  watch: {
    "this.$refs.uploader.images"(newValue, OldValue) {
      console.log("this.$refs.uploader.images");
      console.log(newValue);
      this.$emit("image");
    },
  },
};
</script>
<style lang="scss">
.v-image__image--cover {
  background-size: contain;
  }
</style>
